package accrue.analysis.goals;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.frontend.Scheduler;
import polyglot.frontend.goals.Goal;
import polyglot.frontend.goals.VisitorGoal;
import polyglot.types.TypeSystem;
import accrue.AccrueScheduler;
import accrue.analysis.visit.InlineFinalConstants;

public class InlineFinalConstantsGoal extends VisitorGoal {
    public static Goal create(Scheduler scheduler, Job job, TypeSystem ts,
            NodeFactory nf) {
        return scheduler.internGoal(new InlineFinalConstantsGoal(job, ts, nf));
    }

    protected InlineFinalConstantsGoal(Job job, TypeSystem ts, NodeFactory nf) {
        super(job, new InlineFinalConstants(job, ts, nf));
    }

    @Override
    public Collection<Goal> prerequisiteGoals(Scheduler scheduler) {
        List<Goal> l = new ArrayList<Goal>();
        l.add(scheduler.ReachabilityChecked(job));
        l.add(scheduler.ConstantsChecked(job));
        l.add(scheduler.ExceptionsChecked(job));
        l.add(scheduler.ExitPathsChecked(job));
        l.add(scheduler.InitializationsChecked(job));
        l.add(scheduler.ConstructorCallsChecked(job));
        l.add(scheduler.ForwardReferencesChecked(job));

        l.add(((AccrueScheduler) scheduler).helper()
                                           .MakeNarrowingAssignmentsExplicit(job));
        return l;
    }
}
